#ifndef _DATA_H_
#define _DATA_H_

#include <cstdio>
#include <zlib.h>

#define DLOOP(x,data) \
  for ( Doc *x = (data).docs; x != (data).docs + (data).ndocs; ++x )
#define FLOOP(x,doc)						\
  for( struct {int *id;float *val;} x = {(doc).fid,(doc).fval} ; x.id != (doc).fid + (doc).flen; x.id++, x.val++ )
#define LLOOP(x,doc) \
  for( int *x = (doc).labels; x != (doc).labels + (doc).llen; ++x )



struct Doc {
  int *fid , *labels;
  float *fval;
  int flen, llen, docid;  

  void parse ( char * );
  void parse ( Doc * );
  void print ();
  void readBinary ( gzFile );
  void writeBinary ( gzFile );
  Doc();
  ~Doc();
};



struct Data {
  int ndocs;
  Doc * docs;
  int * labels, llen;

  Data( Data * , int );
  void parse ( const char * );
  void parse ( Data * , int sel );
  void print ();
  void writeBinary ( const char * );
  void readBinary ( const char *);

  Data();
  ~Data();
};


int fexist(const char *filename);


#endif
