#ifndef _HINFO_H_
#define _HINFO_H_

#include <map>
#include <set>
#include <vector>

/* This method is totally unprotected against graphs, if the input
   is graph and path is requested, it will keep rotating forever */

struct HInfo { 
  std::map<int,int> parent,level;
  std::map<int, std::vector<int> > children;
  std::set<int> labels;

  HInfo ( const char * );
  
  int Parent ( int n ) { 
    if ( parent.count(n) ) 
      return parent[n]; 
    else
      return -1;
  }

  int Level ( int n ) {
    return level[n];
  }

  int isLeaf ( int n ) {
    return children.count(n) ? 0 : 1 ;
  }
  
  std::vector<int> Children ( int n ) { 
    if ( children.count(n) ) 
      return children[n];
    else 
      return std::vector<int>();
  }

  std::vector<int> getNeighbors( int n ) {
    return Children(n);
  }

  std::vector<int> Labels ( ) {
    return std::vector<int>  ( labels.begin() , labels.end() );
  }

  std::vector<int> getPath( int label ) {
    std::vector<int> path;
    for ( int n = label; n != -1; n = Parent(n) )
      path.push_back(n);
    return path;
  }
};

#endif
