#ifndef _SIMPLE_GBLR_H_
#define _SIMPLE_GBLR_H_

#include <data.h>
#include <hinfo.h>
#include <lbfgsinterface.h>

struct simpleGBLR : LBFGSinterface {

  HInfo *hinfo;  
  Data * dataptr;
  int label , P , bias;
  double lambda;
  double *w, *mean;

  void writeBinary ( const char * );
  void readBinary ( int , const char * );
  double classify ( const Doc * doc );
  double solve ( const char * , int _label , double eps );
  double* getMeans( const char *path );

  double fg ( const double * , double * , int );

  simpleGBLR ( Data *  , double , HInfo * , int bias = 0 );
  simpleGBLR ( int , const char *fname , HInfo * );
  ~simpleGBLR ();

};

#endif
