#ifndef _SIMPLE_GDCD_H_
#define _SIMPLE_GDCD_H_

#include <data.h>
#include <hinfo.h>
#include <lbfgsinterface.h>

struct simpleGDCD {

  HInfo *hinfo;  
  Data * dataptr;

  int label , P , bias;
  double lambda;
  double *w;

  void writeBinary ( const char * );
  void readBinary ( int , const char * );
  void print ( FILE * );
  double * getMeans( const char * path );

  double classify ( const Doc * doc );
  double solve ( const char * , int _label , double eps );

  simpleGDCD ( Data *  , double , HInfo * , int bias = 0 );
  simpleGDCD ( int , const char *fname , HInfo * );
  ~simpleGDCD ();

};

#endif
