#ifndef _SIMPLE_HBLR_H_
#define _SIMPLE_HBLR_H_

#include <data.h>
#include <hinfo.h>
#include <lbfgsinterface.h>

struct simpleHBLR : LBFGSinterface {

  HInfo *hinfo;  
  Data * dataptr;
  int label , P , bias;
  double lambda;
  double *w , *wp;

  void writeBinary ( const char * );
  void readBinary ( int , const char * );
  double classify ( const Doc * doc );
  double solve ( const char * , int _label , double eps );

  double fg ( const double * , double * , int );
  double solveLeaf ( const char * , int _label , double eps );
  double solveNonLeaf ( const char * , int _label , double eps );

  simpleHBLR ( Data *  , double , HInfo * , int bias = 0 );
  simpleHBLR ( int , const char *fname , HInfo * );
  ~simpleHBLR ();

};

#endif
