#ifndef _SIMPLE_HBLRAk_H_
#define _SIMPLE_HBLRAk_H_

#include <data.h>
#include <hinfo.h>
#include <lbfgsinterface.h>
#include <nodeParam.h>

struct simpleHBLRAk : LBFGSinterface {

  Data * dataptr;
  HInfo *hinfo;
  nodeParam *param, *parent;
  std::vector< nodeParam *> children;

  void writeBinary ( const char * );
  void readBinary ( int , const char * );
  double classify ( const Doc * doc );

  double solve ( const char * , int _label , double eps );
  void solveAlpha ( const char *path , int label );
  void solvePrior ( const char * path , int label );

  double fg ( const double * , double * , int );
  double solveLeaf ( double eps );
  double solveNonLeaf ();


  void loadRequired( int label , const char *path );

  simpleHBLRAk ( Data *  , HInfo *  );
  simpleHBLRAk ( int lockl , const char *fname , HInfo * );
  ~simpleHBLRAk ();

};

#endif
