#ifndef _SIMPLE_HDCD_H_
#define _SIMPLE_HDCD_H_

#include <data.h>
#include <hinfo.h>
#include <lbfgsinterface.h>

struct simpleHDCD {

  HInfo *hinfo;  
  Data * dataptr;
  int label , P , bias;
  double lambda;
  double *w , *wp;

  void writeBinary ( const char * );
  void readBinary ( int , const char * );
  void print ( FILE * );

  double classify ( const Doc * doc );
  double solve ( const char * , int _label , double eps );

  double solveLeaf ( const char * , int _label , double eps );
  double solveNonLeaf ( const char * , int _label , double eps );

  simpleHDCD ( Data *  , double , HInfo * , int bias = 0 );
  simpleHDCD ( int , const char *fname , HInfo * );
  ~simpleHDCD ();

};

#endif
