#ifndef _SIMPLE_TBLR_H_
#define _SIMPLE_TBLR_H_

#include <lbfgssolver.h>
#include <data.h>

struct simpleTBLR : public LBFGSinterface { 
  
  Data * dataptr;
  int label , P , bias;
  double lambda;
  double *w, *addnormB2;
  const double *normB;

  double fg ( const double * , double * , int );
  double solve ( const double *, int , double );
  void writeBinary ( const char * );
  void readBinary ( const char * );
  double classify ( const Doc * doc );

  const double * norm() { return addnormB2;}

  simpleTBLR ( Data *  , double , int );
  simpleTBLR ( const char *fname );
  ~simpleTBLR ();
};

#endif
