#include <hinfo.h>
#include <cstdio>
#include <cstdlib>
#include <cassert>

HInfo::HInfo ( const char *str ) {

  int p,n,c,root=0;

  FILE *f = fopen( str , "r" );
  
  if ( f == NULL ) {
    printf("%s\n",str);
    perror(" Unable to open hierarchy file\n");
    exit(0);
  }

  level[root] = 0;
  
  while ( fscanf(f,"%d",&p) == 1 ) {
    labels.insert(p);
    fscanf(f,"%d",&n);
    while ( n-- > 0 ) {
      fscanf(f,"%d",&c);
      parent[c] = p;
      level[c] = level[p] + 1;
      children[p].push_back( c );
      labels.insert(c);
    }
  }
  
  fclose( f );

}
